summaryrefslogtreecommitdiff
path: root/tests.as-root
diff options
context:
space:
mode:
authorRichard Maw <richard.maw@codethink.co.uk>2012-05-14 14:37:52 +0100
committerRichard Maw <richard.maw@codethink.co.uk>2012-05-14 16:35:51 +0100
commit68d045c68b51d1675b3aeb72c301b00a6af10021 (patch)
tree29ef68637dd47e2ba77a29491939453a34cb4463 /tests.as-root
parentbc69a6e4f9eb6c9e317134aa6515349ae3ed9691 (diff)
downloadmorph-68d045c68b51d1675b3aeb72c301b00a6af10021.tar.gz
builder: log to warnings when artifacts overlap
It may be better to print it to the console, but that requires getting self.msg set
Diffstat (limited to 'tests.as-root')
-rwxr-xr-xtests.as-root/make-patch.script19
-rwxr-xr-xtests.as-root/setup18
-rwxr-xr-xtests.as-root/system-overlap.script123
-rw-r--r--tests.as-root/system-overlap.stdout30
4 files changed, 171 insertions, 19 deletions
diff --git a/tests.as-root/make-patch.script b/tests.as-root/make-patch.script
index 0151ef6c..172f3e07 100755
--- a/tests.as-root/make-patch.script
+++ b/tests.as-root/make-patch.script
@@ -19,25 +19,6 @@
set -eu
-# Make a dummy kernel chunk.
-mkdir "$DATADIR/kernel-repo"
-cat <<EOF > "$DATADIR/kernel-repo/linux.morph"
-{
- "name": "linux",
- "kind": "chunk",
- "install-commands": [
- "mkdir -p \"\$DESTDIR/boot\"",
- "touch \"\$DESTDIR\"/extlinux.conf",
- "touch \"\$DESTDIR\"/boot/vmlinuz",
- "touch \"\$DESTDIR\"/boot/System.map"
- ]
-}
-EOF
-"$SRCDIR/scripts/run-git-in" "$DATADIR/kernel-repo" init --quiet
-"$SRCDIR/scripts/run-git-in" "$DATADIR/kernel-repo" add .
-"$SRCDIR/scripts/run-git-in" "$DATADIR/kernel-repo" commit --quiet -m foo \
- > /dev/null
-
# Make a stratum that include hello and kernel chunks.
cat <<EOF > "$DATADIR/morphs-repo/hello-stratum.morph"
{
diff --git a/tests.as-root/setup b/tests.as-root/setup
index 0b78ef9f..59e4a944 100755
--- a/tests.as-root/setup
+++ b/tests.as-root/setup
@@ -115,6 +115,24 @@ git add hello-system.morph
git commit --quiet -m "add morphs"
+# Make a dummy kernel chunk.
+mkdir "$DATADIR/kernel-repo"
+cat <<EOF > "$DATADIR/kernel-repo/linux.morph"
+{
+ "name": "linux",
+ "kind": "chunk",
+ "install-commands": [
+ "mkdir -p \"\$DESTDIR/boot\"",
+ "touch \"\$DESTDIR\"/extlinux.conf",
+ "touch \"\$DESTDIR\"/boot/vmlinuz",
+ "touch \"\$DESTDIR\"/boot/System.map"
+ ]
+}
+EOF
+"$SRCDIR/scripts/run-git-in" "$DATADIR/kernel-repo" init --quiet
+"$SRCDIR/scripts/run-git-in" "$DATADIR/kernel-repo" add .
+"$SRCDIR/scripts/run-git-in" "$DATADIR/kernel-repo" commit --quiet -m foo \
+ > /dev/null
# Create a morph configuration file.
cat <<EOF > "$DATADIR/morph.conf"
diff --git a/tests.as-root/system-overlap.script b/tests.as-root/system-overlap.script
new file mode 100755
index 00000000..066f39cf
--- /dev/null
+++ b/tests.as-root/system-overlap.script
@@ -0,0 +1,123 @@
+#!/bin/sh
+#
+# If a system has multiple strata that have the same files in them,
+# then this should be notified
+#
+# Copyright (C) 2011, 2012 Codethink Limited
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; version 2 of the License.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License along
+# with this program; if not, write to the Free Software Foundation, Inc.,
+# 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
+
+set -eu
+
+cache="$DATADIR/cache/artifacts"
+chunkrepo="$DATADIR/chunk-repo"
+morphsrepo="$DATADIR/morphs-repo"
+log="$DATADIR/morph.log"
+
+cd "$morphsrepo"
+git checkout --quiet -b overlap master
+cat <<EOF >overlap-system.morph
+{
+ "name": "overlap-system",
+ "kind": "system",
+ "disk-size": "1G",
+ "strata": [
+ "foo-baz-stratum",
+ "foo-barqux-stratum"
+ ]
+}
+EOF
+cat <<EOF >foo-baz-stratum.morph
+{
+ "name": "foo-baz-stratum",
+ "kind": "stratum",
+ "sources": [
+ {
+ "name": "overlap-foo-baz",
+ "repo": "test:chunk-repo",
+ "ref": "overlap"
+ },
+ {
+ "name": "linux",
+ "repo": "test:kernel-repo",
+ "ref": "master"
+ }
+ ]
+}
+EOF
+cat <<EOF >foo-barqux-stratum.morph
+{
+ "name": "foo-barqux-stratum",
+ "kind": "stratum",
+ "sources": [
+ {
+ "name": "overlap-foobar",
+ "repo": "test:chunk-repo",
+ "ref": "overlap"
+ },
+ {
+ "name": "overlap-fooqux",
+ "repo": "test:chunk-repo",
+ "ref": "overlap"
+ }
+ ]
+}
+EOF
+git add overlap-system.morph foo-baz-stratum.morph foo-barqux-stratum.morph
+git commit --quiet -m "add overlapping system"
+
+cd "$chunkrepo"
+git checkout --quiet -b overlap master
+cat <<EOF >overlap-foo-baz.morph
+{
+ "name": "overlap-foo-baz",
+ "kind": "chunk",
+ "install-commands": [
+ "mkdir -p \$DESTDIR/bin",
+ "for f in foo bar baz; do echo echo \$f >\$DESTDIR/bin/\$f; done"
+ ]
+}
+EOF
+
+cat <<EOF >overlap-foobar.morph
+{
+ "name": "overlap-foobar",
+ "kind": "chunk",
+ "install-commands": [
+ "mkdir -p \$DESTDIR/usr/bin \$DESTDIR/bin",
+ "echo echo foobar >\$DESTDIR/usr/bin/foobar",
+ "ln -s /usr/bin/foobar \$DESTDIR/bin/foo",
+ "ln -s /usr/bin/foobar \$DESTDIR/bin/bar"
+ ]
+}
+EOF
+
+cat <<EOF >overlap-fooqux.morph
+{
+ "name": "overlap-fooqux",
+ "kind": "chunk",
+ "install-commands": [
+ "mkdir -p \$DESTDIR/usr/bin \$DESTDIR/bin",
+ "for f in qux fooqux; do echo echo \$f >\$DESTDIR/usr/bin/\$f; done",
+ "ln -s /usr/bin/fooqux \$DESTDIR/bin/foo"
+ ]
+}
+EOF
+git add overlap-*.morph
+
+git commit --quiet -m 'Add overlapping chunks'
+
+"$SRCDIR/scripts/test-morph" \
+ build --verbose --log=$log test:morphs-repo overlap overlap-system.morph
+grep "WARNING\s" $log | sed 's/^.*WARNING/WARNING/'
diff --git a/tests.as-root/system-overlap.stdout b/tests.as-root/system-overlap.stdout
new file mode 100644
index 00000000..c984ab16
--- /dev/null
+++ b/tests.as-root/system-overlap.stdout
@@ -0,0 +1,30 @@
+Build starts
+Building test:morphs-repo overlap overlap-system.morph
+Figuring out the right build order
+Cloning/updating test:chunk-repo
+Cloning/updating test:chunk-repo
+Cloning/updating test:kernel-repo
+Cloning/updating test:chunk-repo
+Cloning/updating test:morphs-repo
+Cloning/updating test:morphs-repo
+Cloning/updating test:morphs-repo
+Building overlap-foo-baz
+Building overlap-foobar
+Building linux
+Building overlap-fooqux
+Building foo-baz-stratum
+Building foo-barqux-stratum
+Building overlap-system
+WARNING Overlaps in artifact foo-barqux-stratum detected
+WARNING Artifacts overlap-foobar, overlap-fooqux overlap with files:
+WARNING bin/foo
+WARNING Overlaps in artifact overlap-system detected
+WARNING Artifacts foo-baz-stratum, foo-barqux-stratum overlap with files:
+WARNING ./bin/bar
+WARNING ./bin/foo
+ chunk.linux
+ chunk.overlap-foo-baz
+ chunk.overlap-foobar
+ chunk.overlap-fooqux
+ stratum.foo-barqux-stratum
+ stratum.foo-baz-stratum